#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>

using namespace std;

typedef unsigned char byte;
typedef unsigned short word;

#ifdef TOP_OBJECT
#define EXTERN
#else
#define EXTERN extern
#endif

EXTERN jmp_buf envbuf;
EXTERN long outa;
EXTERN long dira;
EXTERN long cnt;
EXTERN long clkfreq;
EXTERN long ina[32];
EXTERN long stackptr;

#define true  1
#define false 0
#define NEGX 0x80000000

#define waitcnt(parm)
#define strsize(str) strlen((char *)(str))
#define strcomp(str1, str2) (strcmp((void *)(str1), (void *)(str2)) == 0)
#define bytemove(dst, src, num) memcpy((void *)(dst), (void *)(src), num)
#define wordmove(dst, src, num) memcpy((void *)(dst), (void *)(src), (num)*2)
#define longmove(dst, src, num) memcpy((void *)(dst), (void *)(src), (num)*4)
#define bytefill(dst, val, num) memset((void *)(dst), val, num)

#define ROL(x, y) ((((unsigned long)(x)) >> (32 - y)) | ((x) << (y)))
#define ROR(x, y) ((((unsigned long)(x)) >> (y)) | ((x) << (32 - y)))
#define SHR(x, y) (((unsigned long)(x)) >> (y))
#define LIMMAX(x, y) ((x) < (y) ? (x) : (y))
#define LIMMIN(x, y) ((x) > (y) ? (x) : (y))
#define SEXB(x) ((((long)(x)) << 24) >> 24)
#define SEXW(x) ((((long)(x)) << 16) >> 16)
#define ABS(x) ((x) >= 0 ? (x) : -(x))
#define MOD(x, y) ((x)%(y))

#define BYTE(ptr) ((byte *)(ptr))
#define WORD(ptr) ((word *)(ptr))
#define LONG(ptr) ((long *)(ptr))

static long repeat_from(long& i, long from, long to, long step)
{
    if (to <= from)
    {
        i += step;
        return (from <= i && i <= to);
    }
    else
    {
        i -= step;
        return (to <= i && i <= from);
    }
}

static void wordfill(long dst, long val, long num)
{
    word *wordptr = (word *)dst;
    while (num-- > 0) *wordptr++ = val;
}

static void longfill(long dst, long val, long num)
{
    long *longptr = (long *)dst;
    while (num-- > 0) *longptr++ = val;
}

static long cognew(long pasmaddr, long paraddr)
{
    return 1;
}
