typedef struct symbolS {
    char *name;
    int value;
    int type;
    int size;
    int array;
} symbolT;

#define TYPE_PUB      1
#define TYPE_CONSTANT 2
#define TYPE_VAR      3
#define TYPE_DAT      4
#define TYPE_LOCAL    5
#define TYPE_OBJECT   6

int AddSymbol();
void PrintSymbolTable();
void RemoveLocalSymbols();
int FindSymbol();
int GetSymbolType();
int GetSymbolSize();
int GetSymbolArray();
void SetSymbolSize();
void SetSymbolArray();
void IncrSymbolArray();
char *CopyString(char *str);
